"""init

Revision ID: f0c1c7c66e52
Revises: 
Create Date: 2024-09-05 12:37:31.298735

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = 'f0c1c7c66e52'
down_revision: Union[str, None] = None
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('execution',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('deployment_id', sa.String(), nullable=True),
    sa.Column('time_allotment', sa.Integer(), nullable=True),
    sa.Column('inputs', sa.JSON(), nullable=True),
    sa.Column('state', sa.Enum('CREATED', 'RUNNING', 'COMPLETED', 'CANCELED', 'ERROR', name='execution_state'), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('node_pool',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('selector', sa.JSON(), nullable=False),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('name')
    )
    op.create_table('registration',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('site_id', sa.String(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('deployment',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('version', sa.String(), nullable=True),
    sa.Column('container_image', sa.String(), nullable=True),
    sa.Column('kind', sa.Enum('ACTION', 'TRIGGER', name='kind'), nullable=True),
    sa.Column('execution_type', sa.Enum('GRPC_V1', 'SLURM_SSH_V1', name='execution_type'), nullable=True),
    sa.Column('deployment_type', sa.String(), nullable=True),
    sa.Column('addons', sa.JSON(), nullable=True),
    sa.Column('log_level', sa.String(), nullable=True),
    sa.Column('internal_endpoint', sa.String(), nullable=True),
    sa.Column('node_pool_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['node_pool_id'], ['node_pool.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('input_definition',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('execution_id', sa.String(), nullable=True),
    sa.Column('type', sa.Enum('BOOLEAN', 'STRING', 'INTEGER', 'FLOAT', 'FILE', 'DIRECTORY', 'BYTES', name='io_type'), nullable=False),
    sa.Column('optional', sa.Boolean(), nullable=False),
    sa.ForeignKeyConstraint(['execution_id'], ['execution.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('output_definition',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('execution_id', sa.String(), nullable=True),
    sa.Column('type', sa.Enum('BOOLEAN', 'STRING', 'INTEGER', 'FLOAT', 'FILE', 'DIRECTORY', 'BYTES', name='io_type'), nullable=False),
    sa.Column('optional', sa.Boolean(), nullable=False),
    sa.ForeignKeyConstraint(['execution_id'], ['execution.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('resources',
    sa.Column('cpu', sa.Float(), nullable=True),
    sa.Column('time', sa.Float(), nullable=True),
    sa.Column('memory', sa.BigInteger(), nullable=True),
    sa.Column('gpu', sa.Integer(), nullable=True),
    sa.Column('deployment_id', sa.String(), nullable=False),
    sa.ForeignKeyConstraint(['deployment_id'], ['deployment.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('deployment_id')
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('resources')
    op.drop_table('output_definition')
    op.drop_table('input_definition')
    op.drop_table('deployment')
    op.drop_table('registration')
    op.drop_table('node_pool')
    op.drop_table('execution')
    # ### end Alembic commands ###
